//+------------------------------------------------------------------+ 
//|                                  TrendStrength jurik channel.mq4 | 
//|                                                                  | 
//|                                         http://www.forextsd.com  |
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2010, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window 
#property indicator_buffers 4 
#property indicator_color1  DarkOrange
#property indicator_width1  4
#property indicator_color2  White
#property indicator_style2  STYLE_DASH
#property indicator_color3  Red
#property indicator_width3  1
#property indicator_color4  LimeGreen
#property indicator_width4  1
#property indicator_level1  0
#property indicator_levelcolor Violet


extern string TimeFrame        = "Current time frame";
extern int    RVIPeriod        = 10;
extern int    SmoothPeriod     = 10;
extern int    SmoothPhase      =  0;
extern int    HighLowPeriod    = 30;
extern bool   ShowChannel      = true;
extern bool   ShowZigZag       = true;
extern bool   Interpolate      = true;

extern int    buyarrowwidth    = 2;
extern color  buyarrowcolor    = Lime;
extern int    sellarrowwidth   = 2;
extern color  sellarrowcolor   = Crimson;
extern int    buy1arrowwidth   = 2;
extern color  buy1arrowcolor   = Aqua;
extern int    sell1arrowwidth  = 2;
extern color  sell1arrowcolor  = Magenta;


extern string _                = "alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;




double TS[];
double ZigZagBuffer[];
double HighBuffer[];
double LowBuffer[];
double ZigZagLow[];
double ZigZagHigh[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;



int init() 
  { 
   IndicatorBuffers(7);  
   SetIndexBuffer(0,TS);           SetIndexLabel(0,"TS"); 
   SetIndexBuffer(1,ZigZagBuffer); SetIndexLabel(1, NULL);  SetIndexStyle(1,DRAW_SECTION);       
   SetIndexBuffer(2,HighBuffer);
   SetIndexBuffer(3,LowBuffer);
   SetIndexBuffer(4,ZigZagLow);
   SetIndexBuffer(5,ZigZagHigh);
   SetIndexBuffer(6,trend);
   
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(4,0);
   SetIndexEmptyValue(5,0);
   SetIndexEmptyValue(6,0);
   
   if (ShowChannel)
   {
   SetIndexStyle(2,DRAW_LINE);
   SetIndexStyle(3,DRAW_LINE);
   }
   else      
   {
   SetIndexStyle(3,DRAW_NONE);
   SetIndexStyle(4,DRAW_NONE);
   }
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
  IndicatorShortName(timeFrameToString(timeFrame) + " rvi on jurik channel"); 
   
   return(0); 
  } 

int deinit() 
  { 
  for(int j=Bars; j>=0; j--)
      {
      ObjectDelete("Sell"+DoubleToStr(j,0));
      ObjectDelete("Buy" +DoubleToStr(j,0));

      ObjectDelete("Sell1"+DoubleToStr(j,0));
      ObjectDelete("Buy1" +DoubleToStr(j,0));

      }

   return(0); 
  } 

int start() 
  { 
   
   int lastZag;
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-1);
   if (returnBars)  { TS[0] = limit+1; return(0); }
         
   if (ShowZigZag)
   for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZigZagLow[lastZag] != 0 || ZigZagHigh[lastZag] != 0) break;
         
   if (calculateValue || timeFrame==Period())
   {

   for(i=limit; i>=0; i--)
   {           
   TS[i]        = iCustom(NULL,0,"RVI on jurik",RVIPeriod,SmoothPeriod,SmoothPhase,0,i);
   LowBuffer[i] = TS[ArrayMinimum(TS,HighLowPeriod,i)];
   HighBuffer[i]= TS[ArrayMaximum(TS,HighLowPeriod,i)];
   
   trend[i] = trend[i+1];
   if (TS[i] > LowBuffer[i]  && TS[i+1]==LowBuffer[i+1])  trend[i] =  1;  
   if (TS[i] < HighBuffer[i] && TS[i+1]==HighBuffer[i+1]) trend[i] = -1; 
   
   if (!ShowZigZag) continue;
      
      if (TS[i] > LowBuffer[i] && TS[i+1]==LowBuffer[i+1]) 
      { 
            ObjectCreate("Buy"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],Low[i]-iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Buy"+DoubleToStr(i,0),OBJPROP_ARROWCODE,228);
            ObjectSet   ("Buy"+DoubleToStr(i,0),OBJPROP_WIDTH,buyarrowwidth);
            ObjectSet   ("Buy"+DoubleToStr(i,0),OBJPROP_COLOR,buyarrowcolor);
           
            }

         if (TS[i] < HighBuffer[i] && TS[i+1]==HighBuffer[i+1]) 
         {  
            ObjectCreate("Sell"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Sell"+DoubleToStr(i,0),OBJPROP_ARROWCODE,230);
            ObjectSet   ("Sell"+DoubleToStr(i,0),OBJPROP_WIDTH,sellarrowwidth);
            ObjectSet   ("Sell"+DoubleToStr(i,0),OBJPROP_COLOR,sellarrowcolor);
            
            }

       
       
         if (HighBuffer[i] > HighBuffer[i+1] && HighBuffer[i+1]==HighBuffer[i+2])
            {
            ObjectCreate("Buy1"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],Low[i]-iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Buy1"+DoubleToStr(i,0),OBJPROP_ARROWCODE,225);
            ObjectSet   ("Buy1"+DoubleToStr(i,0),OBJPROP_WIDTH,buy1arrowwidth);
            ObjectSet   ("Buy1"+DoubleToStr(i,0),OBJPROP_COLOR,buy1arrowcolor);
            }

         if (LowBuffer[i] < LowBuffer[i+1] && LowBuffer[i+1]==LowBuffer[i+2])
            {
            ObjectCreate("Sell1"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Sell1"+DoubleToStr(i,0),OBJPROP_ARROWCODE,226);
            ObjectSet   ("Sell1"+DoubleToStr(i,0),OBJPROP_WIDTH,sell1arrowwidth);
            ObjectSet   ("Sell1"+DoubleToStr(i,0),OBJPROP_COLOR,sell1arrowcolor);
            }


      
         ZigZagLow[i]  = 0;
         ZigZagHigh[i] = 0;
         if (LowBuffer[i] < LowBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == LowBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  LowBuffer[i];
                   ZigZagLow[i]          =  LowBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (HighBuffer[i] > HighBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == HighBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  HighBuffer[i];
                   ZigZagHigh[i]         =  HighBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (ZigZagBuffer[i] != 0)
            {
               ZigZagBuffer[i] = 0;
               for (lastZag=i+1; lastZag<Bars; lastZag++)
               {
                  if (ZigZagLow[lastZag]  != 0) { ZigZagBuffer[lastZag] = ZigZagLow[lastZag];  break; }
                  if (ZigZagHigh[lastZag] != 0) { ZigZagBuffer[lastZag] = ZigZagHigh[lastZag]; break; }
               }
              }
            }  
         
   return(0); 
  }
  
  if (ShowZigZag)
  for (lastZag=limit+1; lastZag<Bars; lastZag++) if (ZigZagLow[lastZag] != 0 || ZigZagHigh[lastZag] != 0) break;
  
  limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
  for(i=limit; i>=0; i--)
  {
  int y = iBarShift(NULL,timeFrame,Time[i]);
  
  TS[i]           = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RVIPeriod,SmoothPeriod,SmoothPhase,HighLowPeriod,ShowChannel,ShowZigZag,0,y);
  ZigZagBuffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RVIPeriod,SmoothPeriod,SmoothPhase,HighLowPeriod,ShowChannel,ShowZigZag,1,y);
  HighBuffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RVIPeriod,SmoothPeriod,SmoothPhase,HighLowPeriod,ShowChannel,ShowZigZag,2,y);
  LowBuffer[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RVIPeriod,SmoothPeriod,SmoothPhase,HighLowPeriod,ShowChannel,ShowZigZag,3,y);
  ZigZagLow[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RVIPeriod,SmoothPeriod,SmoothPhase,HighLowPeriod,ShowChannel,ShowZigZag,4,y);
  ZigZagHigh[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RVIPeriod,SmoothPeriod,SmoothPhase,HighLowPeriod,ShowChannel,ShowZigZag,5,y);
  
  trend[i] = trend[i+1];
  if (TS[i] > LowBuffer[i]  && TS[i+1]==LowBuffer[i+1])  trend[i] =  1;  
  if (TS[i] < HighBuffer[i] && TS[i+1]==HighBuffer[i+1]) trend[i] = -1; 
  
  if (!ShowZigZag) continue;
      
      if (TS[i] > LowBuffer[i] && TS[i+1]==LowBuffer[i+1]) 
      { 
            ObjectCreate("Buy"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],Low[i]-iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Buy"+DoubleToStr(i,0),OBJPROP_ARROWCODE,228);
            ObjectSet   ("Buy"+DoubleToStr(i,0),OBJPROP_WIDTH,buyarrowwidth);
            ObjectSet   ("Buy"+DoubleToStr(i,0),OBJPROP_COLOR,buyarrowcolor);
           
            }

         if (TS[i] < HighBuffer[i] && TS[i+1]==HighBuffer[i+1]) 
         {  
            ObjectCreate("Sell"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Sell"+DoubleToStr(i,0),OBJPROP_ARROWCODE,230);
            ObjectSet   ("Sell"+DoubleToStr(i,0),OBJPROP_WIDTH,sellarrowwidth);
            ObjectSet   ("Sell"+DoubleToStr(i,0),OBJPROP_COLOR,sellarrowcolor);
            
            }

       
       
         if (HighBuffer[i] > HighBuffer[i+1] && HighBuffer[i+1]==HighBuffer[i+2])
            {
            ObjectCreate("Buy1"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],Low[i]-iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Buy1"+DoubleToStr(i,0),OBJPROP_ARROWCODE,225);
            ObjectSet   ("Buy1"+DoubleToStr(i,0),OBJPROP_WIDTH,buy1arrowwidth);
            ObjectSet   ("Buy1"+DoubleToStr(i,0),OBJPROP_COLOR,buy1arrowcolor);
            }

         if (LowBuffer[i] < LowBuffer[i+1] && LowBuffer[i+1]==LowBuffer[i+2])
            {
            ObjectCreate("Sell1"+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+iATR(NULL,0,20,i)/2.0); 
            ObjectSet   ("Sell1"+DoubleToStr(i,0),OBJPROP_ARROWCODE,226);
            ObjectSet   ("Sell1"+DoubleToStr(i,0),OBJPROP_WIDTH,sell1arrowwidth);
            ObjectSet   ("Sell1"+DoubleToStr(i,0),OBJPROP_COLOR,sell1arrowcolor);
            }


      
         ZigZagLow[i]  = 0;
         ZigZagHigh[i] = 0;
         if (LowBuffer[i] < LowBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == LowBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  LowBuffer[i];
                   ZigZagLow[i]          =  LowBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (HighBuffer[i] > HighBuffer[i+1])
            {
               if (ZigZagBuffer[lastZag] == HighBuffer[lastZag])
                   ZigZagBuffer[lastZag] = 0;
                   ZigZagBuffer[i]       =  HighBuffer[i];
                   ZigZagHigh[i]         =  HighBuffer[i];
                                 lastZag = i;
                                 continue;
            }
         if (ZigZagBuffer[i] != 0)
            {
               ZigZagBuffer[i] = 0;
               for (lastZag=i+1; lastZag<Bars; lastZag++)
               {
                  if (ZigZagLow[lastZag]  != 0) { ZigZagBuffer[lastZag] = ZigZagLow[lastZag];  break; }
                  if (ZigZagHigh[lastZag] != 0) { ZigZagBuffer[lastZag] = ZigZagHigh[lastZag]; break; }
               }
              } 
  
  if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
  if (!Interpolate) continue;
   
   
  datetime time = iTime(NULL,timeFrame,y);
  for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
  double factor = 1.0 / n;
  for(int k = 1; k < n; k++)
   
  TS[i+k]            = k*factor*TS[i+n]            + (1.0-k*factor)*TS[i];
  ZigZagBuffer[i+k]  = k*factor*ZigZagBuffer[i+n]  + (1.0-k*factor)*ZigZagBuffer[i];
  HighBuffer[i+k]    = k*factor*HighBuffer[i+n]    + (1.0-k*factor)*HighBuffer[i];
  LowBuffer[i+k]     = k*factor*LowBuffer[i+n]     + (1.0-k*factor)*LowBuffer[i];
  ZigZagLow[i+k]     = k*factor*ZigZagLow[i+n]     + (1.0-k*factor)*ZigZagLow[i];
  ZigZagHigh[i+k]    = k*factor*ZigZagHigh[i+n]    + (1.0-k*factor)*ZigZagHigh[i];
  }
   
   manageAlerts();
   return(0);
               
}

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Trendstrength jurik trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Trendstrength jurik "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

  


string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}